{% load components %}
{% load static %}
<html>
<head>
    <link rel="stylesheet" href="{% static 'printable.css' %}">
    <style>
        .d-none{
            display: none;
        }
    </style>
    <title>{{object.project.title}}: {{object.title}}</title>
</head>
<body>
<h1>
    {{object.project.title}}: {{object.title}}
</h1>

<table class="table table-sm table-bordered">
    <thead>
        <tr><th>Revision Date</th><th>Author</th><th></th></tr>
    </thead>
    <tbody>
        <tr>
            {% with object as sla %}
            <td>{{sla.date_updated}}</td>
            <td>{{sla.author}}</td>
            <td class="sla-version text-center">
                <span class="currently-viewing d-none badge badge-pill badge-success">Viewing</span>
                <a href="#" class="view-this d-none badge badge-pill badge-primary" onclick="view('current')">View</a>
            </td>
            {% endwith %}
        </tr>
        {% for sla in object.past_versions.all %}
        <tr>
            <td>{{sla.date_updated}}</td>
            <td>{{sla.author}}</td>
            <td class="sla-version text-center">
                <span class="currently-viewing d-none badge badge-pill badge-success">Viewing</span>
                <a href="#" class="view-this d-none badge badge-pill badge-primary" onclick="view('{{sla.id}}')">View</a>
            </td>
        </tr>
        {% endfor %}
    </tbody>
    
</table>
<h1>Table of Contents</h1>
        {% with object as sla %}
        <div class="sla-view d-none" id="current">
            {{sla.body|markdown_with_toc}}
        </div>
        {% endwith %}
        {% for sla in object.past_versions.all %}
        <div class="sla-view d-none" id="{{sla.id}}">
            {{sla.body|markdown_with_toc}}
        </div>
        {% endfor %}


<script>
    const searchParams = new URLSearchParams(window.location.search);
    let currently_viewing = searchParams.get('view') || 'current'
    view(currently_viewing, true)

    function updateURL(val){
        searchParams.set('view', val)
        let newurl = window.location.protocol + "//" + window.location.host + window.location.pathname + '?' + searchParams.toString();
        window.history.pushState({path: newurl}, '', newurl)
    }

    function view(val, squash_url_change){
        let views = document.querySelectorAll('.sla-view')
        let links = document.querySelectorAll('.sla-version')

        for (let i=0; i < views.length; i++){
            let content = views[i]
            let link = links[i]
            console.log(i)

            let id = content.getAttribute('id')
            if ( id == val){
                content.classList.remove('d-none')
                link.querySelector('.currently-viewing').classList.remove('d-none')
                link.querySelector('.view-this').classList.add('d-none')
            }
            else {
                content.classList.add('d-none')
                link.querySelector('.currently-viewing').classList.add('d-none')

                console.log(link.querySelector('.view-this'))
                link.querySelector('.view-this').classList.remove('d-none')
            }
        }

        if (!squash_url_change){
            updateURL(val)
        }
    }
</script>
</body>
</html>